/*!
 * cleave.js - 0.1.2
 * https://github.com/nosir/cleave.js
 * Apache License Version 2.0
 *
 * Copyright (C) 2012-2016 Max Huang https://github.com/nosir/
 */
!function(e,t,r){"use strict";var a=function(e,r){var o=this;if("string"==typeof e)o.element=t.querySelector(e);else{if("undefined"==typeof e.length)return;o.element=e.length>0?e[0]:e}r.initValue=o.element.value,o.properties=a.DefaultProperties.assign({},r),o.init()};a.prototype={init:function(){var e=this,t=e.properties;(t.numeral||t.phone||t.creditCard||t.date||0!==t.blocks.length)&&(t.maxLength=a.Util.getMaxLength(t.blocks),e.element.addEventListener("input",e.onChange.bind(e)),e.element.addEventListener("keydown",e.onKeydown.bind(e)),e.initPhoneFormatter(),e.initDateFormatter(),e.initNumeralFormatter(),e.onInput(t.initValue))},initNumeralFormatter:function(){var e=this,t=e.properties;t.numeral&&(t.numeralFormatter=new a.NumeralFormatter(t.numeralDecimalMark,t.numeralDecimalScale,t.numeralThousandsGroupStyle,t.delimiter))},initDateFormatter:function(){var e=this,t=e.properties;t.date&&(t.dateFormatter=new a.DateFormatter(t.datePattern),t.blocks=t.dateFormatter.getBlocks(),t.blocksLength=t.blocks.length,t.maxLength=a.Util.getMaxLength(t.blocks))},initPhoneFormatter:function(){var t=this,r=t.properties;if(r.phone)try{r.phoneFormatter=new a.PhoneFormatter(new e.Cleave.AsYouTypeFormatter(r.phoneRegionCode),r.delimiter)}catch(o){throw new Error("Please include phone-type-formatter.{country}.js lib")}},onKeydown:function(e){var t=this,r=t.properties,a=e.which||e.keyCode;return 8===a&&t.element.value.slice(-1)===r.delimiter?void(r.backspace=!0):void(r.backspace=!1)},onChange:function(){this.onInput(this.element.value)},onInput:function(e){var t=this,r=t.properties,o=e,n=a.Util;return r.backspace&&e.slice(-1)!==r.delimiter&&(e=n.headStr(e,e.length-1)),r.phone?(r.result=r.phoneFormatter.format(e),void t.updateValueState()):r.numeral?(r.result=r.numeralFormatter.format(e),void t.updateValueState()):(r.date&&(e=r.dateFormatter.getValidatedDate(e)),e=n.strip(e,r.delimiterRE),e=n.getPrefixAppliedValue(e,r.prefix),r.numericOnly&&(e=n.strip(e,/[^\d]/g)),r.creditCard&&n.headStr(r.result,4)!==n.headStr(e,4)&&(r.blocks=a.CreditCardDetector.getBlocksByPAN(e,r.creditCardStrictMode),r.blocksLength=r.blocks.length,r.maxLength=n.getMaxLength(r.blocks)),e=n.headStr(e,r.maxLength),r.result=n.getFormattedValue(e,r.blocks,r.blocksLength,r.delimiter),void(o!==r.result&&t.updateValueState()))},updateValueState:function(){var e=this;e.element.value=e.properties.result},setPhoneRegionCode:function(e){var t=this,r=t.properties;r.phoneRegionCode=e,t.initPhoneFormatter(),t.onChange()},setRawValue:function(e){this.onInput(e)},getRawValue:function(){var e=this,t=e.properties;return a.Util.strip(e.element.value,t.delimiterRE)},getFormattedValue:function(){return this.element.value},destroy:function(){var e=this;e.element.removeEventListener("input",e.onChange.bind(e)),e.element.removeEventListener("keydown",e.onKeydown.bind(e))},toString:function(){return"[Cleave Object]"}},"object"==typeof module&&"object"==typeof module.exports&&(a.NumeralFormatter=require("./shortcuts/NumeralFormatter"),a.DateFormatter=require("./shortcuts/DateFormatter"),a.PhoneFormatter=require("./shortcuts/PhoneFormatter"),a.CreditCardDetector=require("./shortcuts/CreditCardDetector"),a.Util=require("./utils/Util"),a.DefaultProperties=require("./common/DefaultProperties"),module.exports=exports=a);var o={blocks:{uatp:[4,5,6],amex:[4,6,5],diners:[4,6,4],mastercard:[4,4,4,4],dankort:[4,4,4,4],instapayment:[4,4,4,4],jcb:[4,4,4,4],generalStrict:[4,4,4,7],generalLoose:[4,4,4,4]},re:{uatp:/^(?!1800)1\d{0,14}/,amex:/^3[47]\d{0,13}/,diners:/^3(?:0([0-5]|9)|[689]\d?)\d{0,11}/,mastercard:/^(5[1-5]|2[2-7])\d{0,14}/,dankort:/^(5019|4175|4571)\d{0,12}/,instapayment:/^63[7-9]\d{0,13}/,jcb:/^(?:2131|1800|35\d{0,2})\d{0,12}/},getBlocksByPAN:function(e,t){var r=o.blocks,a=o.re;return t=!!t,a.amex.test(e)?r.amex:a.uatp.test(e)?r.uatp:a.diners.test(e)?r.diners:a.mastercard.test(e)?r.mastercard:a.dankort.test(e)?r.dankort:a.instapayment.test(e)?r.instapayment:a.jcb.test(e)?r.jcb:t?r.generalStrict:r.generalLoose}};"object"==typeof module&&"object"==typeof module.exports&&(module.exports=exports=o);var n=function(e){var t=this;t.blocks=[],t.datePattern=e,t.initBlocks()};n.prototype={initBlocks:function(){var e=this;e.datePattern.forEach(function(t){"Y"===t?e.blocks.push(4):e.blocks.push(2)})},getBlocks:function(){return this.blocks},getValidatedDate:function(e){var t=this,r="";return e=e.replace(/[^\d]/g,""),t.blocks.forEach(function(a,o){if(e.length>0){var n=e.slice(0,a),i=e.slice(a);switch(t.datePattern[o]){case"d":parseInt(n,10)>31&&(n="31");break;case"m":parseInt(n,10)>12&&(n="12")}r+=n,e=i}}),r}},"object"==typeof module&&"object"==typeof module.exports&&(module.exports=exports=n);var i=function(e,t,r,a){var o=this;o.numeralDecimalMark=e||".",o.numeralDecimalScale=t||2,o.numeralThousandsGroupStyle=r||i.groupStyle.thousand,o.delimiter=a||","};i.groupStyle={thousand:"thousand",lakh:"lakh",wan:"wan"},i.prototype={format:function(e){var t,r,a=this,o="";switch(e=e.replace(/[A-Za-z]/g,"").replace(a.numeralDecimalMark,"M").replace(/[^\dM]/g,"").replace("M",a.numeralDecimalMark),r=e,e.indexOf(a.numeralDecimalMark)>=0&&(t=e.split(a.numeralDecimalMark),r=t[0],o=a.numeralDecimalMark+t[1].slice(0,a.numeralDecimalScale)),a.numeralThousandsGroupStyle){case i.groupStyle.lakh:r=r.replace(/(\d)(?=(\d\d)+\d$)/g,"$1"+a.delimiter);break;case i.groupStyle.wan:r=r.replace(/(\d)(?=(\d{4})+$)/g,"$1"+a.delimiter);break;default:r=r.replace(/(\d)(?=(\d{3})+$)/g,"$1"+a.delimiter)}return r.toString()+o.toString()}},"object"==typeof module&&"object"==typeof module.exports&&(module.exports=exports=i);var l=function(e,t){var r=this;r.delimiter=t||" ",r.delimiterRE=new RegExp(r.delimiter,"g"),r.formatter=e};l.prototype={setFormatter:function(e){this.formatter=e},format:function(e){var t=this;t.formatter.clear(),e=e.replace(/[^\d+]/g,""),e=e.replace(t.delimiterRE,"");for(var r,a="",o=!1,n=0,i=e.length;i>n;n++)r=t.formatter.inputDigit(e.charAt(n)),/[\s()-]/g.test(r)?(a=r,o=!0):o||(a=r);return a=a.replace(/[()]/g,""),a=a.replace(/[\s-]/g,t.delimiter)}},"object"==typeof module&&"object"==typeof module.exports&&(module.exports=exports=l),a.NumeralFormatter=i,a.DateFormatter=n,a.PhoneFormatter=l,a.CreditCardDetector=o,a.Util=Util,a.DefaultProperties=DefaultProperties,"object"==typeof module&&"object"==typeof module.exports?module.exports=exports=a:"function"==typeof define&&define.amd?define(function(){return a}):"object"==typeof e&&(e.Cleave=a)}(window,document);